#! /usr/bin/perl 
#use	UTF8;
#no UTF8;
#use strict;
use CGI;
use CGI::Pretty;
use CGI qw/:standard -$check *table *Tr *form *html *blockquote/ ;
#use CGI qw/:standard  *table *Tr *form *html *blockquote/ ;

$CGI::POST_MAX=1024 *100;	# max 100 KB uploads

use locale;
use encoding "latin1";
#use encoding "utf8";


my $check       = 0;
my $dpath       = "Adressen";
my $bfile       = "$dpath/block.tab";
my $dfile       = "$dpath/codierung.tab";
my $dnewfile    = "$dpath/new.tab";
my $logfile     = "$dpath/changes.log";
my $textfile    = "$dpath/changes.txt";
my $htmlfile    = "$dpath/changes.html";
my $plzfile     = "$dpath/PLZ.tab";
my $lfile       = "ags/a.log";
my $job	        = "search";
my $var         = 0;
my $i           = 0;
my $toggle	= 0;
my @sort;


my (@id,@ags,@name,@www,@plz,@typ,@kz,@area,
    @price,@method,@bike,@begin,@freq,@for,
    @contact,@address,@email,@vorwahl,@tel, @fax,
    @town,@created,@status,@lon,@lat,@comment);
my (%plon,%plat); # hash of plz coordinates
my ($html_style, $html_header, $html_footer);

init();
#report_error();
#report_use();

#print start_html('opengeodb');
print header();
print $html_style;
print $html_header;


print "RC:".raw_cookie(),p if $check;
print "QS: ".query_string,p if $check;
print "URL: ".url(),p if $check;
print Dump if $check;

access_log();
#search_form();
#results();

my $show=param("show");
my $hide=param("hide"); # hide records without bike encoding
my $sort=param("sort");
my $search=param("search");

$hide="H";

if($search) { 
    $search =~ s/^ *(.*\S)[ ;]*$/$1/;
} else { 
    $search = int(rand(90000)+9999); 
    param('search', "$search (Beispiel; bitte eigene PLZ eingeben)");
}


if (param('new')) {
    edit_id();
} elsif (param("delete")) {
    #delete_id(param("delete"));
} elsif (param("lschen")) {
    delete_id(-param("id"));
    show_id(param("id"));
} elsif (param("Lschung aufheben")) {
    delete_id(param("id"));
    show_id(param("id"));
} elsif (param("action") eq "changes") {
    show_changes();
} elsif (param("action") eq "update") {
    update_loc ();
}  elsif (param("edit")) { # edit old record
    edit_id(param("edit"));
}  elsif (param("show")) { # edit old record
    show_id(param("show"));
}  elsif (param("speichern")) { # edit old record
    update(param("id"));
    show_id(param("id"));
} elsif ($search=~ /^\d{5}$/) {
        search_form();
        compare_distance($search)
} else {
    search_form();
    search_all($search);
    results();
}


print $html_footer, end_html(),"\n";
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub results {
my $ii=0;
my $my_plz;
my $my_level;
my $invalid;
my $background="background-color: rgb(255, 255, 102);";

return if !$i;
$sort="TP" if !$sort;
print hr(), start_table(), 
    Tr({style=>$background},
	th([
		result_link("T"),
		result_link("N"),
		result_link("P"),
		result_link("K"),
		result_link("V")]),
	"<th></th>");

if ($sort) {
my @oldsort = 0..$i-1;
my @sort;
	if    ($sort eq "T") { @sort = sort {$typ[$a] cmp $typ[$b] } @oldsort; }
	elsif ($sort eq "TP") { 
		@sort = sort {$plz[$a] cmp $plz[$b] } @oldsort;
		@sort = sort {$typ[$a] cmp $typ[$b] } @sort; }
	elsif ($sort eq "N") { @sort = sort {$name[$a] cmp $name[$b] } @oldsort; }
	elsif ($sort eq "K") { @sort = sort {$kz[$a] cmp $kz[$b] } @oldsort; }
	elsif ($sort eq "P") { @sort = sort {$plz[$a] cmp $plz[$b] } @oldsort; }
	elsif ($sort eq "V") { @sort = sort {$vorwahl[$a] cmp $vorwahl[$b] } @oldsort; }
	elsif ($sort eq "D") { @sort = sort {$distance[$a] cmp $distance[$b] } @oldsort; }
	foreach $ii (@sort) {
	   next if ($hide eq "H" and !($status[$ii]>0));
	   print result_line($ii);
	}
 
} else {
	while ($ii < $i) {
	   next if ($hide eq "H" and !($status[$ii]>0));
	   print result_line($ii++);
	}	
}

print end_table();
return '';
}
# C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub result_line {
my ($j) = @_;
my $line="";

    $invalid = $status[$j]?"font-weight: bold;":"text-decoration: line-through;";
    $toggle = !$toggle;
    $background= $toggle?"background-color: rgb(204, 204, 204);":"";
    $kz[$j]=~ s/[;,\t\/]/-/g;
    $line = "<tr style=\"$background\">".
	td("$typ[$j]").
    	td({style=>$invalid},
            $www[$j]?a({-href=>"http://$www[$j]"},$name[$j]):$name[$j]).
    	td($plz[$j]).
    	td($kz[$j]).
    	td(telefonf($vorwahl[$j],$tel[$j])).
    	td("<a href=?show=$id[$j]><i>Details</i></a>").
	"</tr>";
    return ($line);
}
# C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub result_link {
my ($header) = @_;
my $url;
my %params =(
T => '?',
N => 'Name',
P => 'PLZ',
K => 'Kz.',
V => 'Telefon',
D => 'km',
);

#$params{$header} = $header if ($params{$header}eq"");
return "!" if $header eq "T" and $sort eq $header ;
return $params{$header} if $sort eq $header;

$url = "sort=$header";
$url = "search=".$search.";$url" if $search;
$url = "hide=".$hide.";$url" if $hide;
$url = "<a href=?$url>$params{$header}</a>";
return $url;
}
# C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub telefonf { # formatierte Telefonnummer (01 23) 4 56 78-9
my ($n1,$n2)=@_;
$vorwahl = $n1 if $n2;
$nummer = $n2?$n2:$n1;
$vorwahl = "" if $nummer =~ /^0/;
return "" if !$nummer;
$vorwahl =~ s{((?:\d\d)+)$}{
    $n = $1;
    $n =~ s/(..)/ $1/g;
    "$n"
}ge;
$vorwahl =~ s/^\s?(\d.*)$/\($1\) / if $vorwahl =~ /[1-9]/;
$nummer =~ s{((?:\d\d)+)(-\d+)?$}{
    $n = $1;
    $f = $2;
    $n =~ s/(..)/ $1/g;
    "$n$f"
}ge;
$nummer =~ s/^ *//;
$nummer = "$vorwahl $nummer";
$nummer =~ s/^ *//;
return $nummer;
}
# C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub compare_distance {
my ($rplz)=@_;
my $cplz; # compare value
my ($rlat,$rlon);
my ($clat,$clon);
my $rdistance;
my $ii=0;
my $j=0;
my @oldsort;
my $table;
my $background="background-color: rgb(255, 255, 102);";
my $map; # google map url

print "Vergleiche Entfernung zu $rplz\n", br if $check;

hash_plz();
if ($plon{$rplz}) {
    $rlon = $plon{$rplz}; # hash reference
    $rlat = $plat{$rplz}; # hash reference
} else {
    ($rlon,$rlat) = search_plz(">".$rplz);

}
print "ref, $rplz, $rlon, $rlat, oo\n",br if $check;

$show="all";
search_all();
while ($ii < $i) {
    print "$ii: PLZ=$plz[$ii],$lat[$ii],$lat[$ii], -> ",
        distance ($rlon,$rlat,$lon[$ii],$lat[$ii]), "\n",br if $check;
    $distance[$ii]= $rplz==$plz[$ii] ? 0 :
	distance ($rlon,$rlat,$lon[$ii],$lat[$ii]) ;
    if ( $distance[$ii] < 200) {
        foreach $cplz (split /[;,]/, $area[$ii]) { 
            next if !$plon{$cplz};
	    if($cplz == $rplz) { $rdistance = 0;} 
            else {$rdistance = distance ($rlon,$rlat,$plon{$cplz},$plat{$cplz});}
            print "$rdistance " if $check;
            if ($rdistance < $distance[$ii]) {
                $distance[$ii]=$rdistance;
                $plz[$ii]=$cplz;
                print "$ii: area=$cplz, $plon{$cplz}, $plat{$cplz} -> $rdistance\n",br if $check;
            } 
            last if $rdistance > 100;
        }
    }
    $ii++;
}

@oldsort = 0 .. $i-1;
@sort = sort { $distance[$a] <=> $distance[$b] } @oldsort;

$ii=0;
$table = start_table(). 
    Tr({style=>$background},th(["","Name", "PLZ","Kz.", "Telefon","lat","lon","km",
        "<a href=?new=$rplz><i>NEU</i></a>"]));

foreach $j (@sort) {
    next if ($hide eq "H" and !($status[$j]>0));
    last if $ii++ > 20 or $distance[$j] > 50;
    $invalid = $status[$j]?"font-weight: bold;":"text-decoration: line-through;";
    $background= (int($ii/2) == int(($ii+1)/2))?"background-color: rgb(204, 204, 204);":"";

    $kz[$j]=~ s/;/-/g;
    if ($lat[$j]) {
	$map = "$address[$j]" if $address[$j];
	$map = ($town[$j] and !($map =~ /$town[$j]/)) ?
		"&near=$map, $town[$j]" :
		"&near=$map";
    	$map =~ s/;/,/g;
	$map = "$name[$j]$map";
	$map = "ADFC $map" if $typ[$j] eq "A";
	$map =~ s/ (LV|KV|OG|SG) / /g;
    $map =~ s/ /+/g;
    $map = url_map($lat[$j],$lon[$j],$map);
    }
    $table=$table . "<tr style=\"$background\">".
        td($typ[$j]).
        td({style=>$invalid},$www[$j]?a({-href=>"http://$www[$j]"},$name[$j]):$name[$j]).
        td($plz[$j]).
        td($kz[$j]).
        td(telefonf($vorwahl[$j],$tel[$j])).
        sprintf("<td align=right><i><a href=\"$map\">%0.2f</a></i></td>",$lat[$j]).
        sprintf("<td align=right><i><a href=\"$map\">%0.2f</a></i></td>",$lon[$j]).
        sprintf("<td align=right><b>%0.1f</b></td>",$distance[$j]).
        td("<a href=?show=$id[$j]><i>Details</i></a>").
        "</tr>\n";    
}

print $table,end_table();
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub url_map {
my ($lat,$lon,$address,$name) = @_;
my $map;

$map = $address;
$map = "http://maps.google.de/maps?f=l&hl=de&q=$map&ll=$lat,$lon&z=16&om=1&t=m";
return $map;
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_distance {
my ($country, $locid,$distance) = @_;
my $dfile = $dpath."/".$country.".tab";
my $my_plz;
my ($my_lat,$my_lon);
my ($latmin,$latmax,$lonmin,$lonmax);
my @distance;

print "Suche nach Umkreis $distance in $dfile\n",p;# if $check;

search_locid($country, $locid);
return if !$lat[0] or !$lon[0];
$latmin = $lat[0] - d_lat($distance);
$latmax = $lat[0] + d_lat($distance);
$lonmin = $lon[0] - d_lon($lat[0],$distance);
$lonmax = $lon[0] + d_lon($lat[0],$distance);
$i++;
print " $latmin..$latmax / $lonmin..$lonmax ($d_lat/$d_lon) \n",p; # if $check;
open (KEYD, "<:encoding(iso-8859-1)", $dfile) or die "can not open $dfile\n";
while (<KEYD>) {

	($locid[$i], $ags[$i], $name[$i], $ort[$i], $lat[$i], $lon[$i], 
	$amt[$i], $plz[$i], $vorwahl[$i],$einwohner[$i], $flaeche[$i], $kz[$i], 
	$typ[$i], $level[$i], $of[$i], $invalid[$i]) 
		= split /[\t\n]/;
	#	or print "malformatted input line:\n\t".$_."\n",p;
	if ($lat[$i]>$latmin and $lat[$i] <$latmax 
	   and $lon[$i]>$lonmin and $lon[$i]<$lonmax) {
	   $distance[$i] = distance($lon[$0],$lat[0],$lon[$i],$lat[$i]);
	   print "$locid[$i]: $distance[$i], $ort[$i]; $lon[$i] / $lat[$i]\n",br;
	   $i++ if $distance[$i] < $distance ;
	}
	print "$_\n",p if $check;
	if ($i>100) {
	   print $ort?
               "Abbruch der Suche von \"$ort\" nach 100 Treffern\n":
               "Abbruch nach 100 Treffern\n",
		p;
	   last; }
}		
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
# arccos(sin(B_lat)*sin(A_lat)+cos(B_lat)*cos(A_lat)*cos(B_lon - A_lon))
sub distance {
my ($A_lon,$A_lat,$B_lon,$B_lat) = @_;
my $earth=6378.137; # radius for Europe

return ($earth*abs( acos(
    sin_deg($B_lat) * sin_deg($A_lat) + 
    cos_deg($B_lat) * cos_deg($A_lat) * cos_deg($B_lon - $A_lon))));
}
sub d_lon {
my ($lat,$distance) = @_;
return(abs(acos(
    (cos($distance/$earth) - sin_deg($lat)*sin_deg($lat)) / 
    (cos_deg($lat)*cos_deg($lat)))
#   *45/atan2(1,1)
    ));
}
sub d_lat {abs(($_[0]/$earth)
#   45/atan2(1,1)
    )}
sub rad { my $pi = atan2(1,1)*4; return ($pi * $_[0] / 180);}
sub sin_deg {sin(rad($_[0]))} 
sub cos_deg {cos(rad($_[0]))} 
sub acos { atan2(sqrt(abs(1 - $_[0] * $_[0])), $_[0] )}

sub bit {
my ($x,$m)=@_;
my $y = sprintf "%b",$x;
return ($y=~ /(1)(?:.){$b}$/);
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_plz {
my ($plz) = @_;
my $ref;

print "Suche nach $plz in $plzfile\n",p if $check>1;

open (KEYP, "<:encoding(iso-8859-1)", $plzfile) or die "can not open $plzfile\n";

if($plz =~ /^>/ ){
    $plz=~ s/>//;
    while (<KEYP>) {
        ($ref) =  /^\d+\t(\d{5})\t/;
        last if $ref> $plz;
        print "$ref + " if $check;
    }
    print "unbekannte PLZ: $plz; nchste PLZ: $ref\n",br;
} else {
    while (<KEYP>) {
        last if /^\d+\t$plz\t/;
    }

}

($lon,$lat) = /^(?:\d+\t\d{5}\t)([\.0-9]+)\t([\.0-9]+)\t/ ;
	   # or print "malformatted input line:\n\t".$_."\n",p;
	
		
print "$_\n",p if $check;
close (KEYP);
return($lon,$lat);
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub hash_plz {
my ($plz,$lon,$lat);
print "Suche nach $plz in $plzfile\n",p if $check>1;

open (KEYP, "<:encoding(iso-8859-1)", $plzfile) or die "can not open $plzfile\n";
while (<KEYP>) {
($plz,$lon,$lat) = /^(?:\d+\t)(\d{5})\t([\.0-9]+)\t([\.0-9]+)\t/ ;
	   # or print "malformatted input line:\n\t".$_."\n",p;
$plon{$plz} = $lon;
$plat{$plz} = $lat;
}	
print "$_ -> $plz;$lon;$plat{$plz}\n",p if $check;
close (KEYP);
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub update {
my @htmlcommand;
my ($i, $ii);
my @new_error;
my $error_count=0;
my ($lat, $lon);
my $distance;
my @old;
my $id;
my $zz;
my $spamtrap;

my @field=("id","ags","name","www","plz","typ","kz","area",
    "price","method","bike","begin","freq","for",
    "contact","address","email","vorwahl","tel","fax",
    "town","created","status","lon","lat","comment");
 

search_id($id) if $id=param("id");
@oldcommand = split /[\t\n]/;

print "update record $id\n".@oldcommand, p if $check;

$command[0] = $id;
print b("update_new:$locid"),p if $check;

# AGS
$command[1] = param("ags");


#Name
if(param("name")){
    $command[2]=param("name");
} else {
    $new_error[2]="Bitte geben Sie eine Namensbezeichnung an!"; 
    $error_count++;
}

#WWW
if(param("www")){
    $command[3]=param("www");
    $command[3]=~ s/^ *http:\/\///;
} else {
    $new_error[3]="Eine Web-Adresse wre sehr hilfreich gewesen..."; 
    $error_count++;
}

#PLZ
if(param("plz")){
    $command[4]=param("plz");
    $new_error[4]="Die PLZ ist keine fnfstellige Ziffernfolge" 
        if !($command[4] =~ s/.*(\d{5}).*/$1/);
    $new_error[4]= $new_error[4] . " Die PLZ wurde von ".
        param("plz") . " nach ". $command[4] . " umgewandelt."
        if !($command[4] eq param("plz"));
} else {
    $new_error[4]="Ohne PLZ-Angabe ist keine Umkreissuche mglich."; 
    $error_count++;
}

#Typ
 $command[5]=param("typ");

#KZ
if(param("kz")){
    $command[6]=param("kz");
    $spamtrap=1  if($command[6]=~ /[^A-Z,; ]/);
    $command[6] =~ tr/a-z/A-Z/;
    $command[6] =~ tr/-;,\/\n/,/;
    $command[6] =~ tr/,A-Z/,/cs;
    $command[6] =~ s/^,*([^,].*)$/$1/;
    $command[6] =~ s/(.*[^,]),*$/$1/;
    $command[6] =~ s/,+/,/g;
} 

#PLZ-Gebiet
if(param("area")){
    $command[7] =   param("area");
    $command[7] =  $command[7] .",".param("plz") if
        !($command[7] =~ /$command[4]/);
    $command[7] =~ tr/,\/\n /;;;;/;
    $command[7] =~ tr/;0-9/;/cs;
    $command[7] =~ s/^;*([^;].*)$/$1/;
    $command[7] =~ s/(.*[^;]);*$/$1/;
    $command[7] =~ s/;+/;/g;
} 




#Preis
if(param("price")){
    $command[8] = param("price");
    $command[8] =~ s/^Mitglieder: *[\n\r]//g;
    $command[8] =~ s/Nichtmitglieder: *[\n\r]//g;
    $command[8] =~ s/Rabatte fr: *$//g;
    $command[8] =~ s/\s*\n/;/g;
} 
#Codiermethode
if(param("method")){
    if(param("method") eq "EIN-Codierung mit Gravur") {
        $command[9]="EIN"; }
    else { $command[9]=param("method"); }
} 
$command[9]=~ s/[\n\r]/; /g;

#Fahrradcodierung
$command[10]=param("bike");

#seit Jahr
$command[11]=param("begin");

#Hufigkeit
$command[12]=param("freq").";".param("freqp").";".param("freqv");
$command[12]=~ s/^[; ]*(.*)[; ]*$/\1/;
$command[12]="" if param("freq") eq 0;

#Wertsachencodierung etc.
$command[13]=param("for");
$command[13]=~ s/[\n\r]/; /g;

#Kontaktperson
$command[14]=param("contact");

#Kontaktadresse
$command[15]=param("address");

#E-Mail
$command[16]=param("email");

#Vorwahl
$command[17]=param("vorwahl");
$command[17]=~ s/ //g;
$command[17]=~ s/[^a-z0-9A-Z]*$//g;
$command[17]=~ s/^[^a-zA-Z0-9]*//g;

#Telefon
$command[18]=param("tel");
$command[18]=~ s/ //g;
$command[18]=~ s/[^a-z0-9]*$//g;

#Telefax
$command[19]=param("fax");
$command[19]=~ s/ //g;
$command[19]=~ s/[^a-z0-9]*$//g;
$command[19]=~ s/^\(*${command[17]}[-\)\/]*//;

#Ort
$command[20] = param("town");


### date ###
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                                                localtime(time());
my $changed =  
    sprintf("%04d-%02d-%02d %02d:%02d", ($year+1900), ($mon+1), $mday,$hour,$min);
$command[21] = $oldcommand[21]?$oldcommand[21]:$changed;

# status
$command[22] = 1;


# Koordinaten
if (param("lon") and param("lat")) {
    $command[23]=param("lon");
    $command[24]=param("lat");
    $distance = sprintf("%0.2f", 
	distance(param("lon"),param("lat"),search_plz(param("plz"))))
        if param("lon") and param("plz");

    $new_error[23]="Die angegebenen Referenzkoordinaten $command[23]/$command[24] ".
        "weichen um $distance km ".
        "von den Referenzkoordinaten der Postleitzahl $command[4] ab." if $distance>5;
} elsif (param("lon") or param("lat")) {
   $zz = param("lon").param("lat");
    ($command[24],$command[23]) = ($zz =~ /&ll=([\.0-9]+),([\.0-9]+)&/);
} elsif (param("plz")) {
    ($command[23],$command[24]) = search_plz(param("plz")) if param("plz");
     $command[23] = sprintf("%0.4f",$command[23]);
     $command[24] = sprintf("%0.4f",$command[24]);
}


#Kommentar
$command[25]=param("comment");
$command[25]=~ s/[\n\r]/;/g;

$ii=1;
$command=$command[0];
print $command[0],"\n",p if $check;
while($ii <= 25) {
    $command = $command . "\t" . $command[$ii];
    print "$ii: $command[$ii]\n",br if $command[$ii] and $check;
    print br,b($new_error[$ii]) ."\n",p if $new_error[$ii];
    $ii++;}
    
$command=~s/[\n\r]/; /g;
$command=~s/[; ]+\t/\t/g;
$command=~s/\t[; ]+/\t/g;

$id = locid_new() if !param("id");

### change log ###
if(param("id")) {
    $ii=0;
    while($ii <= 25) {
        $ii++;
        next if $command[$ii] eq $oldcommand[$ii];
	$command[$ii] =~ s/;+/<br>/g;	
	$oldcommand[$ii] =~ s/;+/<br>/g;	
        $oldcommand = "$oldcommand<tr>".
            "<td valign=top><a href=\"anbieter.pl?edit=$id\">".param("name")."</a></td>".
            "<td valign=top>".$field[$ii]."</td>".
            "<td valign=top>".$oldcommand[$ii]."</td>".
            "<td valign=top>".$command[$ii]."</td>".
            "<td valign=top>".$changed."</td>".
            "<td valign=top><a href=\"anbieter.pl?edit=$id;field=$ii;old=$oldcommand[$ii]\">".
                "<i>revert</i></a></td></tr>\n";

    }
} else {
    $oldcommand = query_string;
    print "old:    $oldcommand\n",br;
    $oldcommand =~ s/;/;;/g;
    $oldcommand =~ s/;[^=]*=;//g;
    $oldcommand =~ s/;price=Mitglieder%3A%20%0D%0ANichtmitglieder%3A%0D%0ARabatte%20f%C3%BCr%3A;//;
    $oldcommand =~ s/;neu=[^;]*;/;/g;
    $oldcommand =~ s/;\.cgifields=[^;]*$//g;
    $oldcommand =~ s/%0D%0A/<BR> /g;
    $oldcommand =~ s/%20/ /g;
    $oldcommand =~ s/%3A/:/g;
    $oldcommand =~ s/;+/<BR>/g;
    print "old:    $oldcommand\n",br;
    $changed	=~ s/;+/<BR>/g;
    $oldcommand = "<tr>".
        "<td valign=top><a href=\"anbieter.pl?show=$id\">".param("name")."</a></td>".
        "<td valign=top><b>neu</b></td>".
        "<td valign=top colspan=2>$oldcommand</td>".
        "<td valign=top>$changed</td>".
        "<td valign=top>".
            "<a href=\"anbieter.pl?edit=$id\"><i>delete</i></a>".
            "</td></tr>";

}
print table(Tr(th(["Name", "Feld", "alt", "neu", "Datum"]),
    th("&nbsp;")), $oldcommand);

# spamtrap
my      $rip    = remote_host();
my	$spam = 0;
if($spamtrap==1 ||
   $command=~/\[url=/ ||
   $command=~/HREF/ ||
   $command=~/hello/ ||
   $command=~/cialis/ ||
   $command=~/cialis/ ||
   $command=~/viagra/ ||
   $command=~/viagtra/ ||
   $command=~/<.*>/) {
my      $lday   = time() - 24*60*60;
    open (BFILE, ">>", "$bfile");
    print BFILE "$rip\t$lday\n";
    close (BFILE);
    $spam=1;
} else {
open (BFILE, "<", "$bfile");
while (<BFILE>){
	$spam = 1 if(/^$rip\t/);
}
close (BFILE);
}

if($spam) {
	$oldcommand =~ s/<\/td><td.*<\/td><td/<\/td><td/g;
	$oldcommand =~ s/<\/tr>\n.*<\/tr>/<\/tr>/g;
	$oldcommand =~ s/<\/tr>\n.*<\/tr>/<\/tr>/g;
	$oldcommand =~ s/<\/tr>\n.*<\/tr>/<\/tr>/g;
	$oldcommand =~ s/<a href/<i><a href/g;
	$oldcommand =~ s/<\/a>/<\/a><\/i>/g;
}

open (HTMLFILE, ">>",$htmlfile);
print HTMLFILE $oldcommand, "\n";
close (HTMLFILE);

if($spam) {
        return 0;
}

if(param("id")) {
    write_data($command);
} else {
    print $command if $check;
    open (DFILE, ">>:encoding(iso-8859-1)", "$dpath/codierung.tab") 
        or print "datafile not available: $dpath/codierung.tab\n",p;
    print DFILE "$id$command\n";
    close (DFILE);
}
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub write_data {
my ($command) =@_;
my $i = 0;
my $ii = 0;
my ($id) = $command =~ /^([0-9]+)\t/;
my @data;




### lock and update tab file ###
my $locked = 1;
while ($locked) {
    open (LOCKFILE, "<", "$dpath/.codierung.lock");
        if (<LOCKFILE> > time()-100) {
            print time(), ": waiting for unlock\n",p;
            sleep 10;
        } else {
            close (LOCKFILE);
            open (LOCKFILE, ">", "$dpath/.codierung.lock");
            print LOCKFILE time();
            $locked=0;
        }
    close (LOCKFILE);
}

open (DFILE, "<:encoding(iso-8859-1)", "$dpath/codierung.tab") 
    or die "datafile not available: dpath/codierung.tab\n",p;
while (<DFILE>) {
    if (/^$id\t/) {
        $data[$i] = "$command\n"; 
    } else {
        $data[$i]=$_;
    }
    $i = $i+1;
}
close (DFILE);
#print "$i lines read\n",p;

open (DFILE, ">:encoding(iso-8859-1)", "$dpath/.codierung.tab") or die "datafile not writable\n",p;
while ($ii < $i) {
    print DFILE $data[$ii];
    $ii = $ii+1;
}
close (DFILE);
#print ($ii-1) . ' lines written\n',p;


rename "$dpath/codierung.tab", "$dpath/.codierung.bkup";
rename "$dpath/.codierung.tab", "$dpath/codierung.tab";
unlink "$dpath/.codierung.lock";
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub delete_id {
my ($id) =@_;
my $line;
my $v = ($id<0)?0:1;
search_id(abs($id));
$line = $_;
#print "$line\n",br;
$line =~ s/(([^\t]*\t){22})([^\t]*\t)/$1$v\t/;
#print "$line\n",br;
write_data ($line);
print h2("Eintrag wurde ",($id<0)?"gelscht":"freigegeben");
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub sort_plz {$a <=> $b}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub delist {
my @list = @_;
my $item;
my $string;
foreach $item (@list) {
    $string = "$string,$item";
    print "$item\n" if $check;
}
print "before:$string\n" if $check;
$string =~ s/^,*(.*),*$/$1/;
print "after:$string\n" if $check;
return ($string);
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub locid_new {
my ($newid)=@_;
my @logdata;
my $i=0;
my $ii=0;

print ">newid:$newid<\n",br if $check;

# get max. newid
$i=0;
open (LOGFILE, "<:encoding(iso-8859-1)", $logfile) 
    or print "could not open logfile $logfile for reading\n";
while (<LOGFILE>) {
    $logdata[$i] = $_;
    if (/max_id\t(\d+)/) {
		$ii = $1;
		if ($newid == $ii) {
			$ii = $newid+1;	
        	$logdata[$i] =~ s/\t$newid$/\t$ii/;
		} else {
        	$newid = $ii+1;
        	$logdata[$i] =~ s/\t$ii$/\t$newid/;
    	}
	}
    $i++;
}
close (LOGFILE);

if (!($ii>1999)) { # take dummy range
    $newid =  2000;
    $logdata[$i] = "max_id\t2001\n";
    $i++;
}

$ii=0;
open (LOGFILE, ">:encoding(iso-8859-1)", $logfile) 
    or die "could not open logfile $logfile for writing\n";
while ($ii <= $i) {
    print LOGFILE $logdata[$ii];
    $ii++;
}
close (LOGFILE);

print ">newid:$newid<\n",br if $check;

return($newid);

}
# C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub edit_id {
my ($lid)=@_;
my $freqp="--";
my $biketag = 1;

if($lid) { search_id($lid) }
else {$plz[0]=param("new")}

print $_ if $check;
    
$ltyp = 
'<select name="typ">
<option value="A">ADFC</option>
<option value="P">Polizei</option>
<option value="H">Fahrradhndler</option>
<option value="I">Initiativen (ehrenamtlich, ABM, ...)</option>
<option value="K">Kodier-Unternehmen</option>
<option value="G">Stadt, Gemeinde</option>
<option value="X">sonstiges</option>
</select>';
$ltyp =~ s/("$typ[$i]")/$1 selected/;
$price[$i]=~ s/;/\n/g;
$comment[$i]=~ s/;;/\r/g;

#freq: $freq;$freqp;$freqv
$freq = $freq[$i];
$freq =~ s/;.*//;
if ($freq[$i] =~ /lich/) {
  $freqp = $freq[$i];
  $freqp =~ s/.*;(\S+lich).*/\1/;
  $freqp =~ s/([^;]+lich).*/\1/;
}
$freqv = "n.V." if $freq[$i] =~ /n\.V\./;
$freq  =~ s/$freqp//;

$biketag = 0 if ($lid and $bike[$id] eq "");

print start_form;
print start_table({-border=>'0'});
print Tr({-valign=>TOP},"<td colspan=2><h3>Adresse<h3></td>");
print Tr({-valign=>TOP},td(b('Typ')),  td($ltyp));
print Tr({-valign=>TOP},td(b('Name')),	td(
    	textfield(-name=>'name',-size=>40,-default=>$name[$i])));
print Tr({-valign=>TOP},td(b('Anschrift')),	
    td(textfield(-name=>'address',-size=>40,-default=>$address[$i])));
print Tr({-valign=>TOP},td(b('PLZ')),	td(
    textfield(-name=>'plz',-size=>5,-default=>$plz[$i])));
print Tr({-valign=>TOP},td(b('Ort')),	td(
    textfield(-name=>'town',-size=>40,-default=>$town[$i])));
print Tr({-valign=>TOP},td(b('Telefon')),  td("(",	
    textfield(-name=>'vorwahl',-size=>6,-default=>$vorwahl[$i]),")",
    textfield(-name=>'tel',-size=>12,-default=>$tel[$i])));
print Tr({-valign=>TOP},td(b('WWW')), td(	
    textfield(-name=>'www',-size=>40,-default=>"http://$www[$i]")));
print Tr({-valign=>TOP},"<td colspan=2><h3>Codierinfos</h3></td>");
print Tr({-valign=>TOP},td(),	td(
    checkbox('bike',$biketag?'checked':'','B','Fahrradcodierung'), 
        "seit dem Jahr",
	textfield(-name=>'begin',-size=>4,-default=>$begin[$i])));
print Tr({-valign=>TOP},td(b('Codiergut')),	
    td(textarea('for',$for[$i],1,50), 
    td("Welche anderen Produkte als Fahrrder werden codiert?")));
print Tr({-valign=>TOP},td(b("Hufigkeit")),  td(
    checkbox('freqv',$freqv,'n.V.','nur nach Vereinbarung'), br,
    radio_group(-name=>'freqp', 
            -values=>['tglich','wchentlich','monatlich','gelegentlich'],
            -default=>"$freqp"), br,
	textfield(-name=>'freq',-size=>3,-default=>$freq)," Codiertage im Jahr"), 
    td("&nbsp;"));
print Tr({-valign=>TOP},td(b('Preis')),	
    td(textarea('price',$price[$i],3,50), 
    td("reprsentative Vergleichspreise")));
print Tr({-valign=>TOP},td(b('Kennzeichen')),	
    td(textarea('kz',$kz[$i],1,50), 
    td("Bitte nennen Sie Fahrzeugkennzeichen der Orte,
    wo Codieraktionen durchgefhrt werden.")));
print Tr({-valign=>TOP},td(b('PLZ-Gebiet')),	
    td(textarea('area',$area[$i],1,50), 
    td("Bitte nennen Sie mglichst einzeln jede PLZ 
    dieser Codierorte.<br> 
    Diese Angaben werden fr eine Umkreissuche verwendet.")));
print Tr({-valign=>TOP},td(b('Methode')),	
    td(textarea('method',$method[$i],1,50), 
    td("z.B. EIN = EIN-Codierschlssel und Gravur")));
print Tr({-valign=>TOP},"<td colspan=2><h3>Kontaktdaten</h3></td>");
print Tr({-valign=>TOP},td(b('E-Mail')),	
    td(	textfield(-name=>'email',-size=>40,-default=>$email[$i])));
#print Tr({-valign=>TOP},td(b('Fax')),  td(
#    textfield(-name=>'fax',-size=>16,-default=>$fax[$i])),td());
print Tr({-valign=>TOP},td(b('Ansprechpartner')),	
    td(textfield(-name=>'contact',-size=>40,-default=>$contact[$i])));
print Tr({-valign=>TOP},td(b('Koordinaten')),  td(
    textfield(-name=>'lat',-size=>16,-default=>$lat[$i]), " / ",
    textfield(-name=>'lon',-size=>16,-default=>$lon[$i])), 
    td("geografische Breite / Lnge",
    '(GPS-Daten), z.B. von <a href="http://maps.google.de/maps?',
    "hl=de&geocode=&q=$address[$i] $plz[$i] $town[$i]",'">Google</a>'));
print Tr({-valign=>TOP},td(b('AGS')),  td(
    textfield(-name=>'ags',-size=>10,-default=>$ags[$i]),
    "<a href=opengeodb.pl?ort=$town[$i]>Suche nach Amtlichem Gemeindeschlssel</a>"),td());
print Tr({-valign=>TOP},td(b('Kommentar')),	
    td(textarea('comment',$comment[$i],3,50)), 
    td());
print Tr({-valign=>TOP},td(),td(
    "Erstellungsdatum: $created[$i]<br>\n", 
    hidden(-name=>'created',-value=>$created[$i]),
    hidden(-name=>'id',-value=>$id[$i]),
    "Status: ", $status[$i]
#	, ($status[$i]>0?
#        "<a href=\"anbieter.pl?delete=$id[$i]\"><i>lschen</i></a>":
#        "<a href=\"anbieter.pl?delete=-$id[$i]\"><i>freigeben</i></a>")

   ),td());
   
#($id[$i],,,,,,,,
#    ,$status[$i],,,) 
   
print "<tr><td></td><td>", 
	submit(-name=>'speichern'),
	($status[$i])?submit(-name=>'lschen'):submit(-name=>'Lschung aufheben').
	"</td><td></td></tr>";
print end_table();
print end_form();

}# C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub show_id {
my ($lid)=@_;

search_id($lid);
print $_ if $check;
    
my %ltyp = (
"A" => "ADFC",
"P" => "Polizei",
"H" => "Hndler",
"I" => "Initiative",
"K" => "Kodier-Unternehmen",
"G" => "Gemeinde",
"X" => "Anbieter");
my %status = (
0 => "gelscht",
1 => "ok",
2 => "ungeprft");
my $ltyp = $ltyp{$typ[$i]};
$price[$i]=~ s/;/<br>/g;


#freq: $freq;$freqp;$freqv
$freq = $freq[$i];
$freq =~ s/;.*//;
if ($freq[$i] =~ /lich/) {
  $freqp = $freq[$i];
  $freqp =~ s/.*;(\S+lich).*/\1/;
  $freqp =~ s/([^;]+lich).*/\1/;
}
$freqv = "n.V." if $freq[$i] =~ /n\.V\./;
$freq  =~ s/$freqp//;

my $email =  "<i><a href=\"mailto:$email[$i]\"$email[$i]</a><i>"
    if $email[$i];
my $address = $address[$i];
my $contact = $contact[$i];
$address =~s/;/<br>/g;
$comment[$i] =~ s/;;/\r<br>/g;

print start_table({-border=>'0'});
print Tr({-valign=>TOP},td(h3($ltyp{$typ[$i]})),  td(h3(
    $www[$i]?
        "<a href=\"http://$www[$i]\">$name[$i]</a>":$name[$i])));
print Tr({-valign=>TOP},td(b("Ort")),   td("$plz[$i] $town[$i]"));
print Tr({-valign=>TOP},td(b("Codierung")),    td(
    ($bike[$i] eq "B")?"Fahrradcodierung":"", 
    $begin[$i]?"seit $begin[$i]":"",
    (($bike[$i] or $begin[$i]) and $for[$i]) ? "<br>":"",
    $for[$i]?"codiert werden: $for[$i]":""));
print Tr({-valign=>TOP},td(b("Termine")),  td(
    ($freq =~ /^\d+$/)?"$freq Codiertage im Jahr<br>":
        $freq?"$freq<br>":"",
    $freqp?"Codierhufigkeit: $freqp<br>":"",
    ($freqv eq 'n.V.')?"Codierung nur nach Vereinbarung":""));
print Tr({-valign=>TOP},td(b("Preis")),	
    td($price[$i]));
print Tr({-valign=>TOP},td(b('Kennzeichen')),	
    td($kz[$i]));
print Tr({-valign=>TOP},td(b('PLZ-Gebiet')),	
    td($area[$i]));
print Tr({-valign=>TOP},td(b('Methode')),	
    td($method[$i]));
print Tr({-valign=>},"<td colspan=2><br><h3>Kontaktdaten</h3></td>");
print Tr({-valign=>TOP},td(b('Anschrift')), td($address));
#print Tr({-valign=>TOP},td(b('E-Mail')),   td($email));
print Tr({-valign=>TOP},td(b('Telefon')),  td(
    telefonf($vorwahl[$i],$tel[$i])));
#print Tr({-valign=>TOP},td(b('Fax')),  td(
#    $fax[$i]?telefonf($vorwahl[$i],$fax[$i]):""));
print Tr({-valign=>TOP},td(b('Ansprechpartner')),   td($contact));
print Tr({-valign=>TOP},"<td colspan=2><br><h3>Details</h3></td>");
print Tr({-valign=>TOP},td(b('Kommentar')),	
    td($comment[$i]));
print Tr({-valign=>TOP},td(b('Koordinaten')),  td(
    "<a href=\"".url_map($lat[$i],$lon[$i])."\">$lat[$i] / $lon[$i]</a>"));
print Tr({-valign=>TOP},td(b('AGS')),  td($ags[$i]));
print Tr({-valign=>TOP},td(b(Status)),td($status[$i], $status{$status[$i]}));
print Tr({-valign=>TOP},td(b(Datum)),td($created[$i]));


    
print end_table();

print h2({align=>CENTER}, "Achtung");

print blockquote("Diese Angaben hier ndern sich hufig und sind daher rasch veraltet. ".
    "Klren Sie deshalb besser telefonisch oder bei den angegebenen Quellen, ".
    "wann die nchsten Codiertermine stattfinden.",p);
    
print blockquote("Beachten Sie, dass grundstzlich bei der Codierung ",
    b("Personalausweis und Kaufbeleg"), " mitzubringen sind.",p);
    
print blockquote("Korrekturen knnen Sie jederzeit ".
    a({href=>"?edit=$id[$i]"},"hier") . " eintragen.",p);
    
show_changes($id[$i]) if $id[$i] gt 0;
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub show_changes {
my ($id) = @_;
my $ii=0;
my @changes;

open (HTMLFILE, $htmlfile) or print "can not open $htmlfile\n";
while (<HTMLFILE>) {
    $changes[$ii] = $_;
    $ii++ if !$id or /show=$id;/;
}
close (HTMLFILE);

if ($ii) {
    print hr(), h3("nderungen");
    print "<table border=1>";
    print Tr(td([b("Name"),b("Feld"),b("alt"),b("neu"),b("Datum"),"&nbsp;"]));
    while ($ii>1) {
        print $changes[--$ii];
    }
    print "</table>";
}
}# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_form {
print start_form(-name=>"plz");
print "Anbieter im Umkreis von PLZ: ",
    '<input type="text" name="search" value="'.$search.
    '" onclick="document.plz.search.value=\'\';">', 
    submit(-name=>'suchen');
# print "Anbieter im Umkreis von PLZ: ",textfield('search'), submit(-name=>'suchen');
#print br, # checkbox('hide',$hide,'H', Eintr�e ohne Fahrradcodierun) #
#    'Eintrge ohne Fahrradcodierung ' .
#    ($hide eq "H"?
#	a({href=>"?search=$search"},"einblenden"):
#	a({href=>"?search=$search;hide=H"},"ausblenden"))
#    if $search;
print end_form();

}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub update_loc {
my @data;
my @line;
my @aplz;
my $bplz;
my $aplz;
my $ii=0;

open (KEYD, "<:encoding(iso-8859-1)", $dfile) or die "can not open $dfile\n";

$i = 0;
if (<KEYD> and /^[^#]/)  { # skip first header line
    $data[0] = $_;
    $i=1;
}
while(<KEYD>){
    ($id[$i],$ags[$i],$name[$i],$www[$i],$plz[$i],$typ[$i],$kz[$i],$area[$i],
    $price[$i],$method[$i],$bike[$i],$begin[$i],$freq[$i],$for[$i],
    $contact[$i],$address[$i],$email[$i],$vorwahl[$i],$tel[$i],$fax[$i],
    $town[$i],$created[$i],$status[$i],$lon[$i],$lat[$i],$comment[$i]) 
		= split /[\t\n]/
		or print "malformatted input line:\n\t".$_."\n";
	print $i . "\t" . $name[$i]."\t" 
	    . $www[$i]."\t". $area[$i]."\n" if $check>2;
    print "area was $area[$i]\n" if $check > 2;
    @aplz=sort sort_plz (split /[,;]/,$area[$i]);

    $bplz="";
    foreach $aplz (@aplz) {
        $bplz = $bplz.";".$aplz if !($bplz=~ /;$aplz;/);
    }
    $area[$i] = $bplz;
    $area[$i] =~ s/^;*(\d.*)/$1/;
    $area[$i] =~ s/^(.*\d)/$1/;
    $area[$i] =~ s/^;+$//;
   #     print "extended to $area[$i]\n";
    ($lon[$i],$lat[$i])=search_plz($plz[$i]) ;
   #         print "at $lon[$i],$lat[$i]\n";

	$i++;
}

close KEYD;
open (KEYD, ">:encoding(iso-8859-1)", $dfile) or die "can not open $dfile\n";
while($ii<$i) {
    print KEYD
    "$id[$ii]\t$ags[$ii]\t$name[$ii]\t$www[$ii]\t$plz[$ii]\t$typ[$ii]\t$kz[$ii]\t$area[$ii]\t".
    "$price[$ii]\t$method[$ii]\t$bike[$ii]\t$begin[$ii]\t$freq[$ii]\t$for[$ii]\t".
    "$contact[$ii]\t$address[$ii]\t$email[$ii]\t$vorwahl[$ii]\t$tel[$ii]\t$fax[$ii]\t".
    "$town[$ii]\t$created[$ii]\t$status[$ii]\t$lon[$ii]\t$lat[$ii]\t$comment[$ii]\n";
    $ii++;
}
close KEYD;
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_all {
my ($term)= @_;
my @data;
open (KEYD, "<:encoding(iso-8859-1)", $dfile) or die "can not open $dfile\n";

$i = 0;

while(<KEYD>){
    ($id[$i],$ags[$i],$name[$i],$www[$i],$plz[$i],$typ[$i],$kz[$i],$area[$i],
    $price[$i],$method[$i],$bike[$i],$begin[$i],$freq[$i],$for[$i],
    $contact[$i],$address[$i],$email[$i],$vorwahl[$i],$tel[$i],$fax[$i],
    $town[$i],$created[$i],$status[$i],$lon[$i],$lat[$i],$comment[$i]) 
		= split /[\t\n]/
		or print "malformatted input line:\n\t".$_."\n";
	print $i . "\t" . $name[$i]."\t" 
	    . $www[$i]."\t". $area[$i]."\n",br if $check>2;

	$i++ if (!$term or /$term/i) and ($status[$i] or $search);
	if ($i>100 and !$show) {
	   print $term?
               "Abbruch der Suche von \"$term\" nach 100 Treffern\n":
               "Abbruch nach 100 Treffern\n",
		p;
	   last; }
}
	print $i . "\t" . $name[$i-1]."\t" 
	    . $www[$i-1]."\t". $area[$i-1]."\n" if $check;


}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_id {
my ($lid) = @_;
my $ref;

print "Suche nach $lid in $dfile\n",p if $check;

open (KEYP, "<:encoding(iso-8859-1)", $dfile) or die "can not open $dfile\n";


while (<KEYP>) {
    last if /^$lid\t/;
}
    
$i=0;
($id[$i],$ags[$i],$name[$i],$www[$i],$plz[$i],$typ[$i],$kz[$i],$area[$i],
    $price[$i],$method[$i],$bike[$i],$begin[$i],$freq[$i],$for[$i],
    $contact[$i],$address[$i],$email[$i],$vorwahl[$i],$tel[$i],$fax[$i],
    $town[$i],$created[$i],$status[$i],$lon[$i],$lat[$i],$comment[$i]) 
		= split /[\t\n]/;
		
print "$_\n",p if $check;
close (KEYP);
return($plz[0]);
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_term {
my ($my_expr) = @_;
#print "search_my_expr: $my_expr\n",p if $check>1;
return '' if !$my_expr;
$my_expr =~ tr/a-z/A-ZAAAAAEEEEIIIIOOOOCN/;
$my_expr =~ tr//AAAAEEEEIIIIOOOOCN/;
$my_expr =~ s/(AE|)/AE/g;
$my_expr =~ s/(OE|)/OE/g;
$my_expr =~ s/(UE|)/UE/g;
$my_expr =~ s/(SS||S|SSS)/SS/g;
$my_expr =~ s/\./\\./g;
$my_expr =~ s/\*/.*/g;
$my_expr =~ tr/-A-Z0-9 \.\*/-/cs;
$my_expr =~ s/^[- ]*//;
$my_expr =~ s/[- ]*$//;
#$my_expr =~ s/^(.{,40})/$1/;
print "search_my_expr: ->$my_expr<-\n",p if $check>1;
return $my_expr;
}
# C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub access_log {

my	$ltime	= ''; # log time
my	$lip	= ''; # log ip
my	$ldom	= ''; # log domain
my	$lday	= time() - 24*60*60;
my	$rip	= remote_host();
my	$dummy;
my	$lurl	= url($locid[0],-query => 1);

$lurl = $lurl =~ s/;[^;]*=;/;/g;



print $lfile."\n" if $check>9;
print time() . "\t$rip\t" . user_agent() . "\t" . referer() . "\n" if $check>9;

open (LOGFILE, ">> $lfile") or die "logfile not available: $!\n";
print LOGFILE time() . "\t$rip\t".
	$lurl . "\t". query_string . "\t" . referer() . "\t" . user_agent() . "\n";
close (LOGFILE);

}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub init {
if(param('debug')) {
	$check = param('debug');
	print "check level = $check\n",p if $check>99;

}


#<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

$html_style ='
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta name="revisit-after" content="99 days">
<meta name="keywords" content="Fahrrad-Codierung, Codierung von Raedern, Anti-Diebstahls-Codierung, Fahrrad codieren">
<title>Codier-Anbieter </title>
<base target="_top">
<link rel="stylesheet" type="text/css" href="../styles/styles.css" media="screen">
<link rel="stylesheet" type="text/css" href="../styles/druck.css" media="print">
</head>';
$html_header='
<body bgcolor="#ffffff" background="../img/home2.jpg">

<!-- config errmsg="Navigation nicht anzeigbar!"-->
<!-- include virtual="../navigation/navi.txt"-->
<!--adfc-logo.txt-->
<div style="position:relative; top:0px;left:0px;">
<table cellpadding=0 cellspacing=0 border=0 width="100%">
<tr>
<td height=105 valign="bottom" style="background-image:url(http://www.fa-technik.adfc.de/img/logo_neu2.gif);background-repeat:no-repeat;">
<a href="http://www.fa-technik.adfc.de/index.html"><img src="http://www.fa-technik.adfc.de/img/fa.gif" alt="Fachausschuss Technik" width=785 height=105 border=0></a></td>
</tr>
<tr><td><img src="http://www.fa-technik.adfc.de/img/onebyone.gif" width=32 height="10" alt="">
<span style="font-size:9px;">
<a href="http://www.adfc.de/" target="_blank">ADFC</a>&nbsp;&gt;&gt;&nbsp;
<a href="http://www.fa-technik.adfc.de/">FA Technik</a> &gt;&gt;&nbsp;
<a href="http://www.fa-technik.adfc.de/Ratgeber/">Ratgeber</a>&nbsp;&gt;&gt;&nbsp;
<a href="http://www.fa-technik.adfc.de/Codierung/">Codierung</a>&nbsp;&gt;&gt;&nbsp;
<a href="http://www.fa-technik.adfc.de/Codierung/anbieter">Anbieter</a>
</span></td></tr>
</table>
</div>

<div style="margin-left:32px;margin-right:10px;">
<table width="98%">
<tr>
<td class="ueberschrift">Codier-Anbieter</td>
</tr>
</table>
<!-- ------------------------------------------------
Wertsachencodierung, Fahrrad-Codierung in Deutschland, Codieraktionen
-------------------------------------------------- -->
';
$html_footer='
<hr>
<address><a href="&#x004D;ailto&#x003A;code&#x0040;adfc-bw&#x002E;de">Martin Trautmann</a></address>
<p>

<!-- include virtual="../navigation/footer.txt"-->
</td>
</tr>
<tr>
<td>&nbsp;</td>
<td>
<div class="druck">
<img src="http://www.fa-technik.adfc.de/img/onebyone.gif" width=630 height=1 alt="">
</div>
<div class="nurdruck">
<hr>
<p><strong>Allgemeiner Deutscher Fahrrad-Club, Fachausschuss Technik - http://www.fa-technik.adfc.de
<!--#echo var="DOCUMENT_URI" --></strong></p>
</div>
</td>
</tr>
</table>
';
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub utf_decode {
my ($my_expr) = @_;
$my_expr =~ s/ä//g;
$my_expr =~ s/ö//g;
$my_expr =~ s/ü//g;
$my_expr =~ s/\\x9f//g;
$my_expr =~ s/\\x84//g;
$my_expr =~ s/%C3%83%C2%B6//g;
$my_expr =~ s/%C3%B6//g;
$my_expr =~ s/\\x96//g;
$my_expr =~ s/\\x9c//g;
return($my_expr);
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub report_error {
my $error = cgi_error;
    if ($error) {
	print header(-status=>$error),
	      start_html('Problems'),
              h2('Request not processed'),
	      strong($error);
        exit 0;
	}
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
